const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Purchase_ordersDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const purchase_orders = await db.purchase_orders.create(
      {
        id: data.id || undefined,

        order_date: data.order_date || null,
        total_cost: data.total_cost || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await purchase_orders.setVendor(data.vendor || null, {
      transaction,
    });

    await purchase_orders.setCompanies(data.companies || null, {
      transaction,
    });

    return purchase_orders;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const purchase_ordersData = data.map((item, index) => ({
      id: item.id || undefined,

      order_date: item.order_date || null,
      total_cost: item.total_cost || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const purchase_orders = await db.purchase_orders.bulkCreate(
      purchase_ordersData,
      { transaction },
    );

    // For each item created, replace relation files

    return purchase_orders;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const purchase_orders = await db.purchase_orders.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.order_date !== undefined)
      updatePayload.order_date = data.order_date;

    if (data.total_cost !== undefined)
      updatePayload.total_cost = data.total_cost;

    updatePayload.updatedById = currentUser.id;

    await purchase_orders.update(updatePayload, { transaction });

    if (data.vendor !== undefined) {
      await purchase_orders.setVendor(
        data.vendor,

        { transaction },
      );
    }

    if (data.companies !== undefined) {
      await purchase_orders.setCompanies(
        data.companies,

        { transaction },
      );
    }

    return purchase_orders;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const purchase_orders = await db.purchase_orders.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of purchase_orders) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of purchase_orders) {
        await record.destroy({ transaction });
      }
    });

    return purchase_orders;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const purchase_orders = await db.purchase_orders.findByPk(id, options);

    await purchase_orders.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await purchase_orders.destroy({
      transaction,
    });

    return purchase_orders;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const purchase_orders = await db.purchase_orders.findOne(
      { where },
      { transaction },
    );

    if (!purchase_orders) {
      return purchase_orders;
    }

    const output = purchase_orders.get({ plain: true });

    output.vendor = await purchase_orders.getVendor({
      transaction,
    });

    output.companies = await purchase_orders.getCompanies({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userCompanies = (user && user.companies?.id) || null;

    if (userCompanies) {
      if (options?.currentUser?.companiesId) {
        where.companiesId = options.currentUser.companiesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.vendors,
        as: 'vendor',

        where: filter.vendor
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.vendor
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  vendor_name: {
                    [Op.or]: filter.vendor
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.companies,
        as: 'companies',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.order_dateRange) {
        const [start, end] = filter.order_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            order_date: {
              ...where.order_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            order_date: {
              ...where.order_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.total_costRange) {
        const [start, end] = filter.total_costRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            total_cost: {
              ...where.total_cost,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            total_cost: {
              ...where.total_cost,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.companies) {
        const listItems = filter.companies.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          companiesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.companiesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.purchase_orders.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('purchase_orders', 'total_cost', query),
        ],
      };
    }

    const records = await db.purchase_orders.findAll({
      attributes: ['id', 'total_cost'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['total_cost', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.total_cost,
    }));
  }
};
